##### Overview

- Download PMD 5.0.4
- What's new in PMD 5.0.4
- PMD in the news
- PMD-related products and books
- Best practices
- Future directions
- Similar projects
- Credits
- License
- What does 'PMD' mean?

##### Usage

- Installation
- Command line usage
- Ant task usage
- Maven plugin usage
- Mvn plugin usage
- IDE plugin usage
- Suppressing warnings
- Finding duplicated code
- JSP support

##### Customizing PMD

- Compiling PMD
- How to write a rule
- Writing XPath rules
- How to make a rule set
- How it works
- Rule guidelines
- PMD developers information
- PMD Release Process

##### For example

- Run PMD on a Sourceforge project

##### Misc.

- XPath tutorial (Gregorian)

##### Rule Sets

- ecmascript
  - Basic Ecmascript
  - Braces
  - Unnecessary
- java
  - Android
  - Basic
  - Braces
  - Clone Implementation
  - Code Size
  - Comments
  - Controversial
  - Coupling
  - Design
  - Empty Code
  - Finalizer
  - Import Statements
  - J2EE
  - JavaBeans
  - JUnit
  - Jakarta Commons Logging
  - Java Logging
  - Migration
  - Naming
  - Optimization
  - Strict Exceptions
  - String and StringBuffer
  - Security Code Guidelines
  - Type Resolution
  - Unnecessary
  - Unused Code
- jsp
  - Basic JSF
  - Basic JSP
- xml
  - Basic XML
- xsl
  - XPath in XSL

##### Project Documentation

- Project Information
- Project Reports

## How to install PMD (and CPD)

### Windows

Requirements:

- Java JRE 1.5 or higher (see section below for Java JRE 1.4 support)
- Winzip or the free 7-zip

Download the latest binary distribution - i.e., pmd-bin-x.xx.zip

Unzip it into any directory, i.e., c:\pmd\

### Unix

Requirements:

- Java JRE 1.5 or higher (see section below for Java JRE 1.4 support)
- The Unix "zip" utility InfoZip

Download the latest binary distribution - i.e., pmd-bin-x.xx.zip

Unzip it into any directory:

                          [tom@hal tmp]$ unzip -q pmd-bin-5.0.4.zip
                          [tom@hal tmp]$ ls -l
                          total 4640
                          drwxrwxr-x    5 tom      tom          4096 Apr 17 16:38 pmd-bin-5.0.4
                          -rw-rw-r--    1 tom      tom       4733312 Jun  9 15:44 pmd-bin-5.0.4.zip
                          [tom@hal tmp]$

Note that the PMD jar file contains the CPD utility as well.